#!/usr/bin/perl
use Jcode;
use CGI qw(:cgi);
$USERDIR = "/home/raku/www/db"; # 実際のディレクトリ名に
$CGIDIR = "/home/raku/www/db";
$TMPLDIR = "$USERDIR/tmpl";
$URL = "http://localhost"; # https://dokoka.net あるいは http://localhost など
$CGIURL = "$URL/db";
$TITLE = "情報ノート"; # デフォルトのタイトル
$KEY = "情報,ノート,メモ";
$DESC = "著者の収集した情報を集約するサイトです。";
$self = $ENV{'SCRIPT_NAME'};
$self =~ s/\?.*$//;

$page = param('page');
if ($page ne 'error') {
    if ($page =~ m#/([^/]*)/([^/]*)/#) { # 2個以上の / はエラー
        $page = "error";
    } else {
        if ($page eq '') { # なければトップページ
            $page = "index"; # 本来 index
        } elsif (-f "$USERDIR/tmpl/$page.html") { # tmpl 内に html が存在
            $page = $page;
        } else {
            $page = "error";
        }
    }
}
$html = read_tmpl("$page\.html");
print_html($TITLE, $html);

exit 0;

sub read_tmpl {
    my ($tmpl) = @_;
    my $html = read_tmpl0("body.html");
    return replace_body($html, $tmpl);
}

# body.html を読む。
sub read_tmpl0 {
    my ($tmpl) = @_;
    my $html = "";
    open (IN, "$TMPLDIR/$tmpl");
    while (<IN>) {
        $html .= $_;
    }
    close (IN);
    return $html;
}

# $tmpl はその中の body と取り替える部分。それを読み、最初の
# TITLE:タイトル
# KEY:キー1,キー2
# DESC:説明
# を読み、あれば $TITLE, $KEY, $DESC にセット。残りを返す。
sub replace_body {
    my ($html, $tmpl) = @_;
    my $body = "";
    open (IN, "$TMPLDIR/$tmpl");
    while(<IN>) {
        $body = $_;
        $body =~ s#[\n\r]##gs;
        if ($body =~ m#^TITLE:\s*(.*)$#s) {
            $TITLE = $1;
        } elsif ($body =~ m#^KEY:\s*(.*)$#s) {
            $KEY = $1;
        } elsif ($body =~ m#^DESC:\s*(.*)$#s) {
            $DESC = $1;
        } else {
            last;
        }
    }
    while(<IN>) {
        $body .= $_;
    }
    close (IN);
    $html =~ s/\$body/$body/;
    return $html;
}

sub print_html {
    my ($title, $html) = @_;
    $html =~ s/\$title/$title/g;
    $html =~ s#\$URL#$URL#g;
    $html =~ s#\$KEY#$KEY#g;
    $html =~ s#\$DESC#$DESC#g;
    print "Content-Type: text/html;\n\n$html";
}

